Attribute VB_Name = "Master"
Option Explicit
Public DynamicCountdown As Integer ' Used to countdown the cycles until we modify the dynamic costs

Public Sub UpdateSim()
  Dim AmountOff As Single
  Dim UpperRange As Single
  Dim LowerRange As Single
  Dim CorrectionAmount As Single

  
  SimOpts.TotRunCycle = SimOpts.TotRunCycle + 1
  Form1.MutCyc = Form1.MutCyc + 1

  TotalSimEnergyDisplayed = TotalSimEnergy(CurrentEnergyCycle)
  CurrentEnergyCycle = SimOpts.TotRunCycle Mod 100
  TotalSimEnergy(CurrentEnergyCycle) = 0
  
  If totnvegsDisplayed < SimOpts.Costs(BOTNOCOSTLEVEL) Then
    SimOpts.Costs(COSTMULTIPLIER) = 0 ' The population has fallen below the threshold to 0 all costs
  ElseIf SimOpts.Costs(USEDYNAMICCOSTS) Then
    AmountOff = totnvegsDisplayed - SimOpts.Costs(DYNAMICCOSTTARGET)
    'If we are more than X% off of our target population either way AND the population isn't moving in the
    'the direction we want or hasn't moved at all in the past 10 cycles then adjust the cost multiplier
    UpperRange = TmpOpts.Costs(DYNAMICCOSTTARGETUPPERRANGE) * 0.01 * SimOpts.Costs(DYNAMICCOSTTARGET)
    LowerRange = TmpOpts.Costs(DYNAMICCOSTTARGETLOWERRANGE) * 0.01 * SimOpts.Costs(DYNAMICCOSTTARGET)
    If (PopulationLastCycle = totnvegsDisplayed) Then
      DynamicCountdown = DynamicCountdown - 1
    Else
      DynamicCountdown = 10
    End If
    If (AmountOff > UpperRange And (PopulationLastCycle < totnvegsDisplayed Or DynamicCountdown <= 0)) Or _
       (AmountOff < -LowerRange And (PopulationLastCycle > totnvegsDisplayed Or DynamicCountdown <= 0)) Then
       
       If AmountOff > UpperRange Then
         CorrectionAmount = AmountOff - UpperRange
       Else
         CorrectionAmount = Abs(AmountOff) - LowerRange
       End If
       
      'Adjust the multiplier. The idea is to rachet this over time as bots evolve to be more effecient.
      'We don't muck with it if the bots are within 10% of the target.  If they are outside the target, then
      'we adjust only if the populatiuon isn't heading towards the range and then we do it my an amount that is a function
      'of how far out of the range we are (not how far from the target itself) and the sensitivity set in the sim
      SimOpts.Costs(COSTMULTIPLIER) = SimOpts.Costs(COSTMULTIPLIER) + (0.0000001 * CorrectionAmount * Sgn(AmountOff) * SimOpts.Costs(DYNAMICCOSTSENSITIVITY))
      
      'Don't let the costs go negative
      If SimOpts.Costs(COSTMULTIPLIER) < 0 Then SimOpts.Costs(COSTMULTIPLIER) = 0
      DynamicCountdown = 10 ' Reset the countdown timer
    End If
  Else
    SimOpts.Costs(COSTMULTIPLIER) = 1
  End If
 
  ExecRobs
  updateshots
  UpdateBots
  
  MoveObstacles
  
  If SimOpts.TotRunCycle Mod 200 = 0 And SimOpts.KillDistVegs Then KillDistVegs RobSize * 30
  If totvegsDisplayed < SimOpts.MinVegs Then VegsRepopulate
  feedvegs SimOpts.MaxEnergy, totvegsDisplayed
End Sub
