Attribute VB_Name = "Buckets_Module"
Option Explicit
'Buckets is what we're calling the quad tree that isn't a tree
'The boxes are unsorted
'maybe we should sort them?
'either by x pos or by index value

'Buckets take less than 200 KB of Ram

Public Const BucketSize As Integer = RobSize * 6
Dim TanLookup(4) As Single

'below is max size divided into BucketSize by BucketSize boxes
Public Buckets(134, 100) As BucketType

Public Type BucketType
  arr() As Integer
  size As Integer 'highest array element with a bot
End Type

'also erases array elements to retrieve memory
Public Sub Init_Buckets()
  Dim a As Integer: Dim b As Integer

  For a = 0 To 134
    For b = 0 To 100
      ReDim Buckets(a, b).arr(0)
      Buckets(a, b).size = 0
    Next b
  Next a

  If TanLookup(0) = 0 Then
    TanLookup(0) = 0.0874886635
    TanLookup(1) = 0.2679491924
    TanLookup(2) = 0.4663096582
    TanLookup(3) = 0.7002075382
    TanLookup(4) = 1#
  End If
  
  For a = 1 To MaxRobs
    If rob(a).exist Then
      'UpdateBotBucket a
    End If
  Next a
End Sub

Public Sub UpdateBotBucket(n As Integer)
  'makes calls to Add_Bot and Delete_Bot
  'if we move out of our bucket
  'call this from outside the function
  
  Dim currbucket As Single, newbucket As vector, changed As Boolean
  With rob(n)
  
  newbucket = .BucketPos
  currbucket = Int(.pos.x / BucketSize)
  
  If .BucketPos.x <> currbucket Then
    'we've moved off the bucket, update bucket
    .BucketPos.x = currbucket
    newbucket.x = currbucket
    changed = True
  End If
  
  currbucket = Int(.pos.y / BucketSize)
  
  If .BucketPos.y <> currbucket Then
    .BucketPos.y = currbucket
    newbucket.y = currbucket
    changed = True
  End If
  
  If changed Then
    Delete_Bot n, .BucketPos
    Add_Bot n, newbucket
  End If
  
  If rob(n).exist = False Then Delete_Bot n, .BucketPos
  
  End With
End Sub

Public Sub Add_Bot(n As Integer, pos As vector)
  Dim a As Integer

  If pos.x < 0 Or pos.y < 0 Or _
    pos.x * BucketSize > SimOpts.FieldWidth Or _
    pos.y * BucketSize > SimOpts.FieldHeight Then
    Exit Sub
  End If
    
  With Buckets(pos.x, pos.y)

    For a = 0 To .size
      If .arr(a) = -1 Then
        .arr(a) = n
        Exit Sub
      End If
    Next a

    'we have to add it to the end somewhere
    If UBound(.arr()) <= .size Then ReDim Preserve .arr(.size + 5) 'faster to redim 5 at a time
    .size = .size + 1
    .arr(.size) = n
  End With
End Sub

Public Sub Delete_Bot(n As Integer, pos As vector)
  Dim a As Integer, b As Integer
  
  If pos.x < 0 Or pos.y < 0 Or _
    pos.x * BucketSize > SimOpts.FieldWidth Or _
    pos.y * BucketSize > SimOpts.FieldHeight Then
    Exit Sub
  End If
  
  With Buckets(pos.x, pos.y)

    For a = 0 To .size
      If .arr(a) = n Then 'we've found the bot
        .arr(a) = -1 'delete the bot
        If .size = a Then 'last bot in array, collapse array
          a = 0
          For b = 0 To .size
            If .arr(b) <> -1 Then a = b
          Next b
          .size = a 'a is now the last actual array element
          If .size = 0 Then ReDim .arr(0)
        End If
        Exit Sub
      End If
    Next a
  End With
End Sub

Public Sub BucketsProximity(n As Integer, Optional ByVal field As Integer = 12)
  'mirror of proximity function
  'remember to not call this if n is a veggy (ie: .view = false)
  Dim x As Long, y As Long
  Dim BucketPos As vector

  BucketPos = rob(n).BucketPos
  For x = EyeStart To EyeEnd
    rob(n).mem(x) = 0
  Next x
  
  For x = rob(n).BucketPos.x - 2 To rob(n).BucketPos.x + 2
    BucketPos.x = x
    For y = rob(n).BucketPos.y - 2 To rob(n).BucketPos.y + 2
      BucketPos.y = y
      CheckBot2Bucket n, BucketPos, field
    Next y
  Next x
End Sub

Private Sub CheckBot2Bucket(n As Integer, pos As vector, field As Integer)
  Dim a As Integer, robnumber As Integer
  
  If pos.x < 0 Or pos.y < 0 Or _
    pos.x * BucketSize > SimOpts.FieldWidth Or _
    pos.y * BucketSize > SimOpts.FieldHeight Then
    Exit Sub
  End If
  
  With Buckets(pos.x, pos.y)
  
  For a = 0 To .size
    robnumber = .arr(a)
    If robnumber > -1 And robnumber <> n Then
      If rob(robnumber).exist Then
        CompareRobots2 n, robnumber, field
      End If
    End If
  Next a
  End With
End Sub

Public Function AnyShapeBlocksBot(n1 As Integer, n2 As Integer) As Boolean
Dim i As Integer
  
  AnyShapeBlocksBot = False
  
  For i = 1 To numObstacles
    If ShapeBlocksBot(n1, n2, i) Then
      AnyShapeBlocksBot = True
      Exit Function
    End If
  Next i
  
End Function

Public Function ShapeBlocksBot(n1 As Integer, n2 As Integer, o As Integer) As Boolean
Dim d1(4) As vector
Dim p(4) As vector
Dim P0 As vector
Dim D0 As vector
Dim delta As vector
Dim i As Integer
Dim s As Single
Dim t As Single
Dim useS As Boolean
Dim useT As Boolean
Dim numerator As Single

  ShapeBlocksBot = False
  
  'Cheap weed out check
  If (Obstacles.Obstacles(o).pos.x > Max(rob(n1).pos.x, rob(n2).pos.x)) Or _
     (Obstacles.Obstacles(o).pos.x + Obstacles.Obstacles(o).width < Min(rob(n1).pos.x, rob(n2).pos.x)) Or _
     (Obstacles.Obstacles(o).pos.y > Max(rob(n1).pos.y, rob(n2).pos.y)) Or _
     (Obstacles.Obstacles(o).pos.x + Obstacles.Obstacles(o).height < Min(rob(n1).pos.y, rob(n2).pos.y)) Then
     Exit Function
  Else
     ShapeBlocksBot = True
  End If
  Exit Function

  
  d1(1) = VectorSet(0, Obstacles.Obstacles(o).width) ' top
  d1(2) = VectorSet(Obstacles.Obstacles(o).height, 0) ' left side
  d1(3) = d1(1) ' bottom
  d1(4) = d1(2) ' right side
  
  p(1) = Obstacles.Obstacles(o).pos
  p(2) = p(1)
  p(3) = VectorAdd(p(1), d1(2))
  p(4) = VectorAdd(p(1), d1(1))
  
  P0 = rob(n1).pos
  D0 = VectorSub(rob(n2).pos, rob(n1).pos)
  For i = 1 To 4
    numerator = Cross(D0, d1(i))
    If numerator <> 0 Then
      delta = VectorSub(p(i), P0)
      s = Cross(delta, d1(i)) / numerator
      t = Cross(delta, D0) / numerator
    
      useT = False
      useS = False
  
      If t >= 0 And t <= 1 Then useT = True
      If s >= 0 And s <= 1 Then useS = True
  
      If useT Or useS Then
        ShapeBlocksBot = True
        Exit Function
      End If
   
    End If
  Next i
End Function
'New compare routine from Nums added for 2.42.3
Public Sub CompareRobots2(n1 As Integer, n2 As Integer, field As Integer)
      Dim ab As vector, ac As vector, ad As vector 'vector from n1 to n2
      Dim invdist As Single, discheck As Single
      Dim eyecellC As Integer, eyecellD As Integer
      Dim a As Integer
      Dim eyevalue As Long
       
      ab = VectorSub(rob(n2).pos, rob(n1).pos)
      invdist = VectorMagnitudeSquare(ab)
      discheck = field * RobSize + rob(n2).radius
      discheck = discheck * discheck
      
      'check distance
      If discheck < invdist Then Exit Sub
      
      If Not shapesAreSeeThrough Then
        If AnyShapeBlocksBot(n1, n2) Then Exit Sub
      End If
      
      invdist = VectorInvMagnitude(ab)
        
      'ac and ad are to either end of the bots, while ab is to the center
      
      ac = VectorScalar(ab, invdist)
      'ac is now unit vector
      
      ad = VectorSet(ac.y, -ac.x)
      ad = VectorScalar(ad, rob(n2).radius)
      ad = VectorAdd(ab, ad)
      
      ac = VectorSet(-ac.y, ac.x)
      ac = VectorScalar(ac, rob(n2).radius)
      ac = VectorAdd(ab, ac)
      
      eyecellD = EyeCells(n1, ad)
      eyecellC = EyeCells(n1, ac)
      
      If eyecellC = 0 And eyecellD = 0 Then Exit Sub
      
      If eyecellC = 0 Then eyecellC = EyeStart + 9
      If eyecellD = 0 Then eyecellD = EyeStart + 1
      
    eyevalue = RobSize * 100 / (RobSize - rob(n1).radius - rob(n2).radius + 1 / invdist)
    If eyevalue > 32000 Then eyevalue = 32000
  
    For a = eyecellD To eyecellC
        If rob(n1).mem(a) < eyevalue Then
          If a = EyeStart + 5 Then
            rob(n1).lastopp = n2
          End If
          rob(n1).mem(a) = eyevalue
        End If
      Next a
    End Sub



Public Sub CompareRobots(n1 As Integer, n2 As Integer, field As Integer)
  Dim ab As vector, ac As vector, ad As vector 'vector from n1 to n2
  Dim invdist As Single, discheck As Single
  Dim eyecellC As Integer, eyecellD As Integer
  Dim a As Integer
  
  ab = VectorSub(rob(n2).pos, rob(n1).pos)
  invdist = VectorMagnitudeSquare(ab)
  discheck = field * RobSize + rob(n2).radius
  discheck = discheck * discheck
  
  'check distance
  If discheck < invdist Then Exit Sub
  invdist = VectorInvMagnitude(ab)
    
  'ac and ad are to either end of the bots, while ab is to the center
  
  ac = VectorScalar(ab, invdist)
  'ac is now unit vector
  
  ad = VectorSet(ac.y, -ac.x)
  ad = VectorScalar(ad, rob(n2).radius)
  ad = VectorAdd(ab, ad)
  
  ac = VectorSet(-ac.y, ac.x)
  ac = VectorScalar(ac, rob(n2).radius)
  ac = VectorAdd(ab, ac)
  
  eyecellD = EyeCells(n1, ad)
  eyecellC = EyeCells(n1, ac)
  
  If eyecellC = 0 And eyecellD = 0 Then Exit Sub
  
  If eyecellC = 0 Then eyecellC = EyeStart + 9
  If eyecellD = 0 Then eyecellD = EyeStart + 1
  
  For a = eyecellD To eyecellC
    If rob(n1).mem(a) < (RobSize * 100 * invdist) Then
      Dim eyevalue As Long
      If a = EyeStart + 5 Then
        rob(n1).lastopp = n2
      End If
      eyevalue = (RobSize * 100 * invdist)
      If eyevalue > 32000 Then eyevalue = 32000
      rob(n1).mem(a) = eyevalue
    End If
  Next a
End Sub

Private Function EyeCells(n As Integer, ab As vector) As Integer
  Dim aimvector As vector
  Dim tantheta As Single
  Dim sign As Integer
  Dim a As Integer
  
  'because we're in the third quadrant (all computer screens work like that)
  'we have to do the opposite of y
  'believe me, this caused some wierd bugs until I figured it out
  aimvector.x = rob(n).aimvector.x
  aimvector.y = -rob(n).aimvector.y
    
  'tantheta = Tan(rob(n1).aim - Atn(ab.Y / ab.X))
  tantheta = Dot(ab, aimvector): If tantheta <= 0 Then Exit Function
  tantheta = Cross(ab, aimvector) / tantheta
  
  If tantheta > 0# Then
    sign = 1
  Else
    sign = -1
    tantheta = -tantheta
  End If

  If tantheta > 1# Then
    Exit Function   'not visible
  End If

  'n2 visible to n1
  For a = 0 To 4
    If tantheta < TanLookup(a) Then 'we've found the right spot
      EyeCells = EyeStart + 5 - sign * a
      Exit Function
    End If
  Next a
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Public Function BucketShotColl(n As Integer) As Integer
'  'doesn't check if the shot moved from bucket to bucket, which might cause problems
'  'we'll fix that later sometime
'
'  Dim ab As vector, ac As vector, bc As vector, bucket As vector
'  Dim MagAB As Single, a As Integer, robnumber As Integer
'  Dim PX As Single, PY As Single
'  Dim dist As Single
'
'  With Shots(n)
'  ab = VectorSub(.pos, .opos)
'  MagAB = VectorMagnitudeSquare(ab)
'
'  bucket = VectorSet(Int(.x / BucketSize), Int(.y / BucketSize))
'
'  If bucket.x < 0 Or bucket.y < 0 Or _
'    bucket.x * BucketSize > SimOpts.FieldWidth Or _
'    bucket.y * BucketSize > SimOpts.FieldHeight Then
'    Exit Function
'  End If
'
'  For a = 0 To Buckets(bucket.x, bucket.y).size
'    If Buckets(bucket.x, bucket.y).arr(a) > 0 Then
'      robnumber = Buckets(bucket.x, bucket.y).arr(a)
'      PX = rob(robnumber).pos.x
'      PY = rob(robnumber).pos.y
'
'      ac = VectorSet(PX - .ox, PY - .oy)
'      bc = VectorSet(PX - .x, PY - .y)
'
'      If Dot(ab, ac) > 0 Then
'        'if AB dot AC > 0 then nearest point is point B
'        dist = VectorMagnitudeSquare(bc)
'      ElseIf Dot(ab, bc) > 0 Then
'        'if AB dot BC > 0 then nearest point is point A
'        dist = VectorMagnitudeSquare(ac)
'      ElseIf MagAB > 0 Then
'        '(AB cross AC)  / ||AB|| = distance
'        'square both sides
'        dist = Cross(ab, ac) ^ 2 / MagAB
'      Else
'        dist = VectorMagnitudeSquare(ac)
'      End If
'
'      If dist <= rob(robnumber).radius * rob(robnumber).radius Then
'        If Shots(n).parent <> robnumber And rob(robnumber).Wall = False Then
'          BucketShotColl = robnumber
'          Exit Function
'        End If
'      End If
'
'    End If
'  Next a
'  End With
'End Function
